var lang      = $('html').attr('lang').toUpperCase();
var local_dev = false;
var callbacks = {
    'required' : {
        'FR' : 'Remplissez tous les champs requis. ',
        'EN' : 'Fill Every required fields. '
    },
    'email'    : {
        'FR' : 'Veuillez entrer une adresse email valide. ',
        'EN' : 'Please enter a valid e-mail address. '
    },
    'error'    : {
        'FR' : 'Un problème est survenu. ',
        'EN' : 'A problem occured. '
    },
    'nobot'    : {
        'FR' : 'Veuillez confirmer que vous êtes bien un humain : rechargez la page et entrez vos données directement. ',
        'EN' : 'Please confirm you are a human : reload page and enter directly your informations. '
    },
    'connection'      : {
        'FR' : 'Connexion réussie. ',
        'EN' : 'Successfull connection. '
    },
    'contact'      : {
        'FR' : 'Message envoyé avec succès. ',
        'EN' : 'Mail sent with success. '
    },
    'file_dld'     : {
        'FR' : 'Téléchargement terminé. ',
        'EN' : 'File downloaded.'
    },
    'funding_error_rate'     : {
        'FR' : 'Le calcul a échoué, veuillez vérifier le taux indiqué. ',
        'EN' : 'undefined'
    },
    'funding_error_duration' : {
        'FR' : 'Le calcul a échoué, veuillez vérifier la durée du prêt. ',
        'EN' : 'undefined'
    },
    'guestb_add' : {
        'FR' : 'Avis enregistré avec succès. ',
        'EN' : 'View saved with success. '
    },
    'logout'      : {
        'FR' : 'Déconnexion réussie. ',
        'EN' : 'Successfull logout. '
    },
    'no_account'   : {
        'FR' : 'Votre compte n\'existe pas ou a été désactivé. ',
        'EN' : 'Your account does not exist or is unactive. '
    },
    'prescription' : {
        'FR' : 'Message envoyé avec succès : vous pourrez venir chercher votre ordonnance à la date prévue. ',
        'EN' : 'Mail sent with success : you can have your prescription at the expected date. '
    },    
    'sub_exist'  : {
        'FR' : 'Votre email est déjà inscrit. ',
        'EN' : 'Your e-mail is already registered. '
    },
    'sub_add'    : {
        'FR' : 'Inscription réussie, merci. ',
        'EN' : 'Successfull subscription, thank-you. '
    },
    'sub_delete' : {
        'FR' : 'Désinscription effectuée. ',
        'EN' : 'Unsubscription done. '
    },
    'sub_error'  : {
        'FR' : 'Votre inscription a échouée. ',
        'EN' : 'Your subscription has failed. '
    },
    'sub_pwd_confirm_error'  : {
        'FR' : 'Vos mots de passe ne sont pas identiques. ',
        'EN' : 'Your passwords are not identical. '
    },
    'reserv_add'   : {
        'FR' : 'Réservation enregistrée avec succès. ',
        'EN' : 'Booking saved with success. '
    },
    'reserv_error' : {
        'FR' : 'Votre réservation a échouée. ',
        'EN' : 'Your booking has failed. '
    },
    'reserv_error_30' : {
        'FR' : 'L\'établissement est fermé à la date voulue. Réouverture le #DATE#. ',
        'EN' : 'The establishment is closed at this date. Will open on #DATE#. '
    },
    'reserv_error_31' : {
        'FR' : 'Aucun bureau n\'est disponible le #DATE#. ',
        'EN' : 'No office is available on #DATE#. '
    },
    'reserv_error_32' : {
        'FR' : 'La salle de réunion n\'est pas disponible le #DATE# à cet horaire (#HOURS#). ',
        'EN' : 'The meeting room is not available on #DATE# at this hour (#HOURS#). '
    },
    'reserv_error_prop' : {
        'FR' : 'Nous avons des disponibilités le #DATE#. ',
        'EN' : 'We have places on #DATE#. '
    },
    'reserv_user_not_logged' : {
        'FR' : 'Vous devez être connecté(e) avant de valider votre réservation. ',
        'EN' : 'You must be connected to validate booking. '
    },
    'user_update'    : {
        'FR' : 'Mise à jour effectuée. ',
        'EN' : 'Successfull update. '
    },
    'user_pwd_change_request'    : {
        'FR' : 'Un email vous a été envoyé avec un lien vous permettant de changer votre mot de passe. ',
        'EN' : 'You will recieve an email with link to change your password. '
    },
    'user_pwd_update'    : {
        'FR' : 'Votre mot de passe a bien été modifié. ',
        'EN' : 'Your password has been modified. '
    },
    'wrong_pwd'   : {
        'FR' : 'Votre mot de passe est erroné. ',
        'EN' : 'Your password is wrong. '
    },
    'form_rgpd' : {
        'FR' : "Veuillez accepter les conditions de validation.",
        'EN' : 'Please confirm saving conditions. '
    },
    'spam_test' : {
        'FR' : 'Veuillez confirmer que vous êtes bien un humain : rechargez la page et entrez vos données directement. ',
        'EN' : 'Please confirm you are a human : reload page and enter directly your informations. '
    }
    
};

// google api markers
var GAPIMarkers = [];

$(document).ready(function(){
    // Soumission formulaire moteur (data-form)
    if($('[data-form]').length > 0){
        var form_input_prefix = 'of_';
        var form_value_parser = '///';
        
        $('[data-form]:not([data-form=""])').each(function(){
            var $form = $(this);
            
            $form.attr('novalidate', '');
            $form.find('input[name]').on('keypress', function(e){
                return e.which !== 13;
            });
            $form.find('[type="file"]').each(function(){
                var input_file_hidden = '<input type="hidden" name="'+$(this).attr('name')+'_hidden">';
                $(this).before(input_file_hidden);
            });
            $form.find('[name]').on('input', function(){
                if($form.find('[name="of_validate_count"]').length){
                    $form.find('[name="of_validate_count"]').val(parseInt($form.find('[name="of_validate_count"]').val()) + 1)
                }
            });
            
            $(this).submit(function(e){
                e.preventDefault();
                
                var form_name = $form.attr('data-form');
                
                var form_values_object  = {};
                var form_values_ajax    = new FormData();
                
                var form_input_selector_memory = [];
                
                $form.find('[name^="'+form_input_prefix+'"]').each(function(){
                    var form_input_name  = $(this).attr('name');
                    var form_input_type  = $(this).attr('type');
                    var form_input_key   = form_input_name.split('-')[0];
                    
                    var form_input_selector = '[name|="'+form_input_key+'"]';
                    if(form_input_type === 'checkbox' || form_input_type === 'radio'){form_input_selector = '[name="'+form_input_name+'"]';}
                    
                    if($.inArray(form_input_selector, form_input_selector_memory) === -1){
                        var form_input_value = '';
                        
                        $form.find(form_input_selector).each(function(){
                            switch (form_input_type){
                            case 'checkbox' :
                            case 'radio'    : {
                                if($(this).is(':checked')){
                                    form_input_value += $(this).val()+form_value_parser;
                                }
                                
                                break;
                            }
                                
                            case 'file' : {
                                
                                // En attendant l'ajax pour les fichiers
                                form_input_value = $(this).val() + form_value_parser;
                                
                                break;
                            }
                                
                            default : {
                                if($(this).val().length){
                                    form_input_value += $(this).val()+form_value_parser;
                                }
                                
                                break;
                            }
                            }
                        });
                        
                        if(typeof(form_input_value) === 'string' && form_input_value.length >= form_value_parser.length){
                            form_input_value = form_input_value.substr(0, form_input_value.length - form_value_parser.length);
                        }
                        
                        form_values_object[form_input_key] = form_input_value;
                        form_values_ajax.append(form_input_key, form_input_value);
                        
                        form_input_selector_memory.push(form_input_selector);
                    }
                });
                
                // console.log(form_name);
                // console.log(form_values_object);
                
                form_values_object['of_form'] = form_name;
                
                switch(form_name){
		case 'add':{
                    users.addFile(form_values_object);
                    break;
                }
                case 'alerte':{
                    emails_alerts.save(form_values_object);
                    break;
                }
                case 'avis':{
                    guestbook.save(form_values_object);
                    break;
                }
		case 'creation-professionnel':
		case 'creation-particulier':{
		    users.create(form_values_object);
		    break;
		}
                case 'desinscription_alerte_email':{
                    emails_alerts.unsubscribe(form_values_object);
                    break
                }
                case 'financer':{
                    realestate_properties.computeFunding(form_values_object);
                    break;
                }
                case 'inscription':{
                    events.doSubscription(form_values_object);
                    break;
                }
                case 'login':{
                    users.doLogin(form_values_object);
                    break;
                }
		case 'messagerie':{
                    users.addMessage(form_values_object);
                    break;
                }
		case 'modifications-1':
		case 'modifications-2':
		case 'modifications-3':
		case 'modifications-4':
		case 'modifications-5':
		case 'modifications-6':{
		    users.update(form_values_object);
		    break;
		}
                case 'newsletter' : {                                       
                    switch (form_values_object.of_subscribe){
                    case '0' : { // Unsubscribe
                        newsletter.doUnsubscribe(form_values_object)
                        break;
                    } 
                    case '1' : { // Subscribe
                        newsletter.doSubscription(form_values_object);
                        break;
                    } 
                    }
                    
                    break;
                }
		case 'recuperation-1':{
		    users.retrievePwd(form_values_object);
		    break;
		}
		case 'recuperation-2':{
		    users.reinitPwd(form_values_object);
		    break;
		}
                case 'reservation':{
                    // prestations_bookings.save(form_values_object);
		    contact.initBooking(form_values_object);
                    break;
                }
                case 'restaurant_reservation':{
                    restaurant_reservations.save(form_values_object);
                    break;
                }
                case 'paiement':{
                    prestations_bookings.doPayment(form_values_object);
                    break;
                }
                case 'search':{
                    realestate_properties.initSearch(form_values_object);
                    break;
                }
                case 'share':{
                    // realestate_properties.share(form_object);
                    vehicles.share(form_values_object);
                    break;
                }
                    
                default : {
                    contact.send(form_values_object);
                    break;
                }
            	}
            });
        });
    }
    
    // Files
    $('body').on('change', '[data-form]:not([data-form=""]) [data-input="file"] [type="file"]', function(){
        var $input_file        = $(this);
        var $input_file_hidden = $(this).prev('[type="hidden"]');
        
        // console.log('CHANGE');
        // console.log($input_file);
        // console.log($input_file_hidden);

	uploadFiles($input_file, $input_file_hidden);
	
    });
    $('body').on('click', '[data-form]:not([data-form=""]) [data-input="file"] [data-input-addon="file"] button', function(){
        var $input_file        = $(this).parent().siblings('[type="file"]');
        var $input_file_hidden = $(this).parent().siblings('[type="hidden"]');
        
        // console.log('RESET');
        // console.log($input_file);
        // console.log($input_file_hidden);
        
        $input_file_hidden.val('');
    });
    // ------------------------------------------
    

    //------------- print event
    $('body').on('click', '[data-print]', function(){

	var dp = $(this).data('print');

	if($('#printFrame-' + dp).length)
	{
	    $('#printFrame-' + dp).get(0).contentWindow.print();
	}
	else if($('#printFrame').length)
	{
	    if($('#printFrame').hasClass('to-redirect'))
	    {
		$('#printFrame').attr('src', './print-' + dp + '.html').load(function(){
		    // nasty hack to be able to print the frame
		    var tempFrame       = $('#printFrame')[0];
		    var tempFrameWindow = tempFrame.contentWindow? tempFrame.contentWindow : tempFrame.contentDocument.defaultView;
		    tempFrameWindow.focus();
		    tempFrameWindow.print();
		});
	    }
	    else
	    {
		$('#printFrame').get(0).contentWindow.print();
	    }

	}
	return false;
    });


    //------------- show message if no element was found
    if($('[data-db-container]').length)
    {
	if(!$('[data-db-container]').children().length)
	{
	    $('[data-dbo="alert"]').addClass('error').show();
	}
	else
	{
	    $('[data-dbo="alert"]').removeClass('error').hide();
	}
    }


    //------------- manage cookies
  /*  $('body').on('click', '[data-cookies="allow"]', function(){
        var data = 'type=legal.setcookieuse&use=1';
        var success = function(res){
            if(res.response){
                $('[data-cookies="forbid"]').removeClass('active');
                $('[data-cookies="allow"]').addClass('active');
                
                $('[data-include^="cookies"]').addClass('hide');
                setTimeout(function(){
                    $('[data-include^="cookies"]').remove();
                }, 1000);
            }
        }
        
        ajaxPost(data, success);
    });
    
    $('body').on('click', '[data-cookies="forbid"]', function(){
        var data = 'type=legal.setcookieuse&use=-1';
        var success = function(res){
            if(res.response){
                $('[data-cookies="allow"]').removeClass('active');
                $('[data-cookies="forbid"]').addClass('active');
                
                $('[data-include^="cookies"]').addClass('hide');
                setTimeout(function(){
                    $('[data-include^="cookies"]').remove();
                }, 1000);
            }
        }
        
        ajaxPost(data, success);
    });*/



    // --------------------------------------------------------------------
    /*********************************************************************
     *
     * Modules events
     *
     *********************************************************************/
    // create change events for modules
    $('body').on('change', '[data-module]', function(){

	var target_parser = '|||';
	var value_parser = '///';
	
	// find module name
	var moduleName = $(this).attr('data-module');
	// search data-db-container if moduleName is not set
	if(moduleName === '')
	{
	    if($('[data-db-container]').length === 1)
	    {
		moduleName = $('[data-db-container]').attr('data-db-container');
	    }
	}

	if(!window[ moduleName ]) return false;

	// manage loader
	$(this).addClass('loading');

	// find form and add / update value
	var form = $('#' + moduleName + '-form');

	// get current nav_page value
	var currentPage = (form.find('#nav_page').length ? form.find('#nav_page').val() : 1);

	// find form and clean values
	$('[data-dbo-filter]').each(function(){
	    var filter = $(this).attr('data-dbo-filter');
	    if(filter && filter !== undefined)
            {
		filter     = filter.replace('_min', '').replace('_max', '');
		if(!form.find('input[name=search_' + filter + ']').length)
		{
		    form.append('<input type="hidden" name="search_' + filter + '" id="search_' + filter + '" value="">');
		}
		else
    		{
		    form.find('input[name=search_' + filter + ']').val('');
		}
	    }
	});

	$('[data-dbin-input]').each(function(){
	    var filter = $(this).attr('data-dbin-input');
	    filter     = filter.replace('_min', '').replace('_max', '');
	    if(filter && filter !== undefined)
            {
		if(!form.find('input[name=search_' + filter + ']').length)
		{
		    form.append('<input type="hidden" name="search_' + filter + '" id="search_' + filter + '" value="">');
		}
		else
    		{
		    form.find('input[name=search_' + filter + ']').val('');
		}
	    }
	});
        
        
	$('[data-dbin-filter-input]').each(function(){
	    var filter = $(this).attr('data-dbin-filter-input');
	    if(filter && filter !== undefined)
            {
                if(!form.find('input[name=search_' + filter + ']').length)
                {
                    form.append('<input type="hidden" name="search_' + filter + '" id="search_' + filter + '" value="">');
                }
                else
                {
                    form.find('input[name=search_' + filter + ']').val('');
                }
            }
	});    
        
        
	/*$('.dropin-value').each(function(){
	  var filter = $(this).attr('name');
	  filter     = filter.replace('_min', '').replace('_max', '');
	  if(form.find('input[name^=search_' + filter + ']').length)
    	  {
	  form.find('input[name^=search_' + filter + ']').val('');
	  }
	  });
        */
	/*
	  $('input[type=checkbox]').each(function(){
	  if($(this).attr('name'))
	  {
	  var filter = $(this).attr('name');
	  filter     = filter.replace('_min', '').replace('_max', '');
	  if(!form.find('input[name=search_' + filter + ']').length)
	  {
	  form.append('<input type="hidden" name="search_' + hidden + '" id="search_' + hidden + '" value="">');
	  }
	  else
    	  {
	  form.find('input[name=search_' + filter + ']').val('');
	  }
	  }
	  });
        */
	
	if($('[data-dbo=categories]').length || $('.news_db_inner'))
	{
            if(form.find('input[name=search_subcategories_id]').length) form.find('input[name=search_subcategories_id]').val(0);
            if(form.find('input[name=search_categories_id]').length) form.find('input[name=search_categories_id]').val(0);
            if(form.find('input[name=search_date]').length) form.find('input[name=search_date]').val('');
            
	}
        
	if(form.find('input[name^=search_id]').length)
	{
            form.find('input[name^=search_id]').val(0);
	}
        

	// find target
	var target = $(this).attr('data-target');
	if(target !== '')
	{
	    // is there a parser
	    if(target.indexOf( target_parser ) > -1)
	    {
		// split values
		targetOrig = target;
		target     = target.split( target_parser );
		var value  = $(this).attr('data-value');
		value = value.split( target_parser );

		var minMaxValues = [];

		for(var i in target)
		{
		    if(!value[ i ] || (value[ i ] === undefined) || (value[ i ] === '') || (value[ i ] === null) || (value[ i ] === 'null')) continue;

		    if ((target[i].indexOf('_min') > -1) || (target[i].indexOf('_max') > -1))
		    {
			var targetTmp = target[ i ].replace('_min', '').replace('_max', '');

			var hidden    = 'search_' + targetTmp;
			if(!form.find('input[name=' + hidden + ']').length)
			{
			    form.append('<input type="hidden" name="' + hidden + '" id="' + hidden + '" value="">');
			}

			// save values
			if(!minMaxValues[ targetTmp ])
			{
			    // find min & max values
			    var minValue = 0;
			    var maxValue = Number.MAX_SAFE_INTEGER;
			    if($('[data-dbo-filter=' + targetTmp + '_min]').length)
			    {
				minValue = $('[data-dbo-filter=' + targetTmp + '_min]').attr('min');
			    }
			    if($('[data-dbo-filter=' + targetTmp + '_max]').length)
			    {
				maxValue = $('[data-dbo-filter=' + targetTmp + '_max]').attr('max');
			    }
			    //
			    minMaxValues[ targetTmp ] = []
			    minMaxValues[ targetTmp ]['min'] = minValue;
			    minMaxValues[ targetTmp ]['max'] = maxValue;
			}
			
			
			if (target[i].indexOf('_min') > -1)
			{
			    minMaxValues[ targetTmp ]['min'] = value[ i ];
			}
			else if (target[i].indexOf('_max') > -1)
			{
			    minMaxValues[ targetTmp ]['max'] = value[ i ];
			}

		    }
		    else
		    {
 			var targetTmp = target[ i ];
			var valueTmp  = value[ i ];

			// check if hidden field exists
			var hidden = 'search_' + targetTmp;
			if(!form.find('input[name=' + hidden + ']').length)
			{
			    form.append('<input type="hidden" name="' + hidden + '" id="' + hidden + '" value="0">');
			}

			form.find('input[name=' + hidden + ']').val(valueTmp);
		    }

		}

		// run through min & max values
		for(var targetTmp in minMaxValues)
		{
		    var hidden = 'search_' + targetTmp;
		    var value  = 'BETWEEN ' + minMaxValues[ targetTmp ]['min'] + ' AND ' + minMaxValues[ targetTmp ]['max'];
		    form.find('input[name=' + hidden + ']').val(value);
		}

		
	    }
	    // no parser datas contain simple values
	    else
	    {
		var value  = $(this).attr('data-value');
		
		// value = value.replace(value_parser, ',');
		
		// check if hidden field exists
		var hidden = 'search_' + target;
		if(!form.find('input[name=' + hidden + ']').length)
		{
		    form.append('<input type="hidden" name="' + hidden + '" id="' + hidden + '" value="">');
		}
		form.find('input[name=' + hidden + ']').val(value);

		if(target === 'categories_id') form.find('input[name=search_subcategories_id]').val(0);
		else if(target === 'subcategories_id') form.find('input[name=search_categories_id]').val(0);
	    }
	}
	else
	{
	    if(form.find('input[name^=search_page]').length)
	    {
		var tmp = form.find('input[name^=search_page]').val();
		form.find('input[name^=search_page]').val(tmp);
	    }
	}
	// find order
	var order = $(this).attr('data-order');
	if(order !== '')
	{
	    // check if hidden field exists
	    var hidden = 'option_order';
	    if(!form.find('input[name=' + hidden + ']').length)
	    {
		form.append('<input type="hidden" name="' + hidden + '" id="' + hidden + '" value="">');
	    }
	    form.find('input[name=' + hidden + ']').val(order);
	}

	// set nav_page
	var page = $(this).attr('data-page');
	if(page !== '')
	{
	    // check if hidden field exists
	    var hidden = 'nav_page';
	    if(!form.find('input[name=' + hidden + ']').length)
	    {
		form.append('<input type="hidden" name="' + hidden + '" id="' + hidden + '" value="">');
	    }
	    form.find('input[name=' + hidden + ']').val(page);
	}

	// set limit
	var limit = $(this).attr('data-items');
	if(limit !== '')
	{
	    // check if hidden field exists
	    var hidden = 'option_limit';
	    if(!form.find('input[name=' + hidden + ']').length)
	    {
		form.append('<input type="hidden" name="' + hidden + '" id="' + hidden + '" value="">');
	    }
	    form.find('input[name=' + hidden + ']').val(limit);
	}

	if($('body').attr('id') == 'index')
	{
	    if(moduleName === 'vehicles')
	    {
		var formTarget = (parseInt($('[data-dbo-filter=states_id]').val()) == 1 ? 'neuf.html' : 'occasion.html');
		form.attr('action', formTarget).submit();
	    }
      
        else if(moduleName === 'realestate_properties')
        {
        window.location = 'biens.html';
        }

	}

	window[ moduleName ].displaySearch();

	// get new nav_page value
        if(!$(this).attr('data-append') || ($(this).attr('data-append') !== 'true'))
	{
	    var newPage = (form.find('#nav_page').length ? form.find('#nav_page').val() : 1);
	    if(currentPage !== newPage)
	    {
		// get container
		var container  = $('[data-db-container="' + moduleName + '"]');
		if(container.length)
		{
		    container  = container.closest('section');
		    var scroll = container.offset().top;
		    if($('[data-dbo="categories"]').length)
		    {
			scroll = $('[data-dbo="categories"]').offset().top;
		    }
		    var outerHeight = 0;
		    if($('#headerDk')) outerHeight = $('#headerDk .container:first-child').outerHeight();
		    else if($('#headerMb')) outerHeight = $('#headerMb').outerHeight();
		    $('html, body').animate({
			scrollTop: scroll - outerHeight
		    }, 'slow');
		}
	    }
	}
	return false;
    });


    //------------- google API

    $('body').on('click', '#of_calcul', function(){

	// manage loader
	$(this).addClass('loading');

	googleAPI.computeDistance();

	return false;
    });

    $('body').on('keypress', '#of_hour, #of_minute', function(event){

	var key = window.event ? event.keyCode : event.which;
	if (event.keyCode === 8 || event.keyCode === 9 || event.keyCode === 46) {
            return true;
	} else if ( key < 48 || key > 57 ) {
            return false;
	} else {
    	    return true;
	}

    });

    $('body').on('focusout', '#of_hour, #of_minute', function(event){

	var id    = $(this).attr('id');
	var value = parseInt($(this).val());

	if((id === 'of_hour') && (value > 23)) $(this).val(23);
	else if(id === 'of_minute')
	{
	    if(value > 59) $(this).val(59);
	    else if($(this).val().length == 1) $(this).val('0' + $(this).val());
	}


    });

    //------------- news
    if(typeof news === 'object')
    {
	$('[data-news-id]').click(function(){	
            news.doLike();        
	});
	
	news.removePlural();
	news.removeFavorite();
	news.removeCategories();
    }

    //------------- products
    updateElementsCounter();


    //------------- users
    $('body').on('click', '[data-logout]', function(e){

	users.doLogout();

	e.preventDefault();
    });


    //------------- get last page save in session
    var lastPage = sessionStorage.getItem(window.location.hostname + '.lastpage');
    if(lastPage === null) $('#erreur').find('button').first().remove();
    else $('#erreur').find('button').first().click(function(){ window.location.href=lastPage;});
    
    //------------- keep page in session
    sessionStorage.setItem(window.location.hostname + '.lastpage', window.location.href);

    //
    $('[data-back="history"]').click(function(){ history.back(); });

    //------------- compute nav back page name
    // if($('.nav .back').length)
    // {
	// // get current url
	// var navBack  = $('.nav .back').find('a');
	// var url      = navBack.attr('href');
	// // find element in main menu
	// var pageName = $('nav.menu a[href="' + url + '"]').html();
	// // add it to back link
	// var navBackHtml = navBack.find('span').last().html();
	// if(navBackHtml !== '') pageName += ' / ';
	// navBack.find('span').last().html(pageName + navBackHtml);
    // }

    //------------- hide others part if empty
    if(!$('.others [data-item]').length)
    {
        $('.others').hide();  
    }

});

$(window).load(function(){

});

$(window).resize(function(){

});


/*********************************************************************
 *
 * common functions
 *
 *********************************************************************/


// access callback_txt via ajax callback
function getCallbackTxt(index){
    lang = lang.toUpperCase();
    if(callbacks[ index ] && callbacks[ index ][ lang ]) return callbacks[ index ][ lang ];
    return '';
}

// js version of sleep function - await waiting(600);
function sleep(milliseconds)
{
    var start = new Date().getTime();
    for (var i = 0; i < 1e7; i++)
    {
	if ((new Date().getTime() - start) > milliseconds)
	{
	    break;
	}
    }
}

// upload files from input
// $('input[type=file]').on('change', uploadFiles);

function uploadFiles(event, event_hidden)
{
    //
    var targetName = event.attr('name');
    var files      = event.prop("files");
    
    if(local_dev) var url = './includes/file_exec/file_upload_fe.php';
    else var url = '/includes/file_exec/file_upload_fe.php';

    // start loader to avoid submit before upload is finished
    var form   = $('input[name=' + targetName + ']').closest('form');
    var submit = null;
    if(form.find('[data-loading]').length)
    {
	form.find('[data-loading]').addClass('loading');
    }
    else
    {
	submit = form.find('[type="submit"]');
	if(submit.length)
	{
	    submit.css('pointer-events', 'none')
	    submit.parent().css('cursor', 'wait')
	}
    }
    
    // Create a formdata object and add the files
    var data = new FormData();
    $.each(files, function(key, value)
	   {
	       data.append(key, value);
	   });

    $.ajax({
	url: url + '?from=' + targetName + '&files',
	type: 'POST',
	data: data,
	cache: false,
	//	dataType: 'json',
	processData: false, // Don't process the files
	contentType: false, // Set content type to false as jQuery will tell the server its a query string request
	complete: function()
	{
	    // stop loader
	    if($('form .loading').length)
	    {
		$('form .loading').removeClass('loading');
	    }
	    else if($('.pagination-button .loading').length)
	    {
		$('.pagination-button .loading').removeClass('loading');
	    }
	    else if((submit !== null) && submit.length)
	    {
		submit.css('pointer-events', 'all')
		submit.parent().css('cursor', 'pointer')
	    }
	},
	success: function(res, textStatus, jqXHR)
	{
	    //
	    if(res)
	    {
		event_hidden.val(res);
	    }
	    else event_hidden.val('');
	},
	error: function(jqXHR, textStatus, errorThrown)
	{
	    // Handle errors here
	    // console.log('ERRORS: ' + textStatus);
	    // stop loader
	}
    });

}


// check email
function checkEmail(txtEmail){
    strMail = txtEmail.replace(/ /g,'');

    var re = /\S+@\S+\.\S+/;
    return re.test(strMail);
}



// Ajax Post Action [data: array / success: callback]
function ajaxPost(data, success){
    $.ajax({
	type: 'POST',
	url: 'index2.php',
	data: data,
	success: success,
	dataType: 'json',
	encoding: 'UTF-8',
	headers : {
            'CsrfToken': $('meta[name="csrf-token"]').attr('content')
	},
	beforeSend: function(){
	    showAjaxOverlay();
	},
	complete: function(){
	    showAjaxOverlay();

	    ajaxComplete();
	},
	error: function(x,e){
	    if (x.status==401)
	    {
		window.location.href = 'index.html';
	    }
	    /*
	      else if(x.status==404)
	      {
	      alert('Requested URL not found.');
	      }
	      else if(x.status==500)
	      {
	      alert('Internel Server Error.');
	      }
	      else if(e=='parsererror')
	      {
	      alert('Error.\nParsing JSON Request failed.');
	      }
	      else if(e=='timeout')
	      {
	      alert('Request Time out.');
	      }
	      else
	      {
	      alert('Unknow Error.\n' + x.responseText);
	      }
	    */
	}
    });
}




// --------------------------------------------------------------------

// Ajax Complete (Events Reloads)
function ajaxComplete(){

    // img
    if($('[data-src]').length && (typeof img === 'function')) img();
    
    // animin
    if($('[data-animin]').length && (typeof animin === 'function')) animin();

    // hoverin
    if($('[data-hoverin]').length && (typeof hoverin === 'function')) hoverin();
    
    // clamp
    if($('[data-clamp]').length && (typeof clamp === 'function')) clamp();

    // stop loader
    if($('.loading').length)
    {
	$('.loading').removeClass('loading');
    }
    else if($('.pagination .loading').length)
    {
	$('.pagination .loading').removeClass('loading');
    }
    else if($('.pagination-button .loading').length)
    {
	$('.pagination-button .loading').removeClass('loading');
    }
    // and reload it on pagination
    if($('.pagination').length)
    {
	//
	var loaderHTML = '<div class="loader"></div>';
	$('.pagination [data-loading]').append(loaderHTML);
    }
    else if($('.pagination_multiple').length)
    {
	//
	var loaderHTML = '<div class="loader"></div>';
	$('.pagination_multiple [data-loading]').append(loaderHTML);
    }

    // reinit gallery 
    if($('[data-db-container=galleries]').length)
    {
	if(typeof gallery === 'function') gallery();
	else if(typeof iba === 'function') iba();
	else if(typeof img === 'function') img();
    }
    // or videos
    else if($('[data-db-container=videos]').length)
    {
	if(typeof iframe === 'function') iframe();
    }

    // set counter
    updateElementsCounter();

    /*
      @todo : 05/10/18 - a ajouter pour rafraichir un slider

      slickin_init($('[data-slickin="slider_name"]')
    */

    if($('[data-slickin]').length)
    {
	$('[data-slickin].to_init').each(function(){
	    slickin_init($(this));
	    $(this).removeClass('to_init');
	});
    }

    /*
      @todo : 05/10/18 - généraliser les data-fancybox qui sont dans le db-container
    */    
    if($('[data-fancybox="gallery"]').length) $('[data-fancybox="gallery"]').fancybox('destroy');

}


function updateElementsCounter()
{
    if($('.counter').length)
    {
	// find data-dbin
	var element  = $('[data-dbin]').attr('data-dbin');
	var maxItems = $('[data-dbin-back=' + element + ']').attr('data-total');
	
	// get span to fill
	var spanTotal = $('.counter');
	// set values
	var spanTotalVal = maxItems;

	spanTotal.html(spanTotalVal);
	// display counter
	$('.counter').css({visibility: 'visible'});
    }
}


function escapeTags( str )
{
    return String( str )
        .replace( /&/g, '&amp;' )
        .replace( /"/g, '&quot;' )
        .replace( /'/g, '&#39;' )
        .replace( /</g, '&lt;' )
        .replace( />/g, '&gt;' );
}


function numFormat(e)
{
    var t = ' ';
    var n;
    e = e + '';
    x = e.split('.');
    x1 = x[0];
    x2 = x.length > 1 ? '.' + x[1] : '';
    var r = /(\d+)(\d{3})/;
    while (r.test(x1)) {
	x1 = x1.replace(r, '$1' + t + '$2');
    }
    n = x1 + x2;
    return n.replace('.', ',');
}

function numNormalise(e)
{
    e = e + '';
    e = e.replace(/,/gi, '.');
    e = e.replace(/\s+/gi, '');
    e = parseFloat(e);
    if(isNaN(e)) e = 0;
    return e;
}

function raZero(e)
{
    for (var t = 0; t < e.length; t++)
    {
	if (isNaN(e[t].value) || !e[t].value)
	{
	    e[t].value = 0;
	}
    }
}

function nl2br(str, is_xhtml)
{
    if (typeof str === 'undefined' || str === null)
    {
        return '';
    }
    var breakTag = (is_xhtml || typeof is_xhtml === 'undefined') ? '<br />' : '<br>';
    return (str + '').replace(/([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1' + breakTag + '$2');
}

function showAjaxOverlay()
{
    if($('.ajax-overlay').length)
    {
	if($('.ajax-overlay').is(':visible')) $('.ajax-overlay').hide();
	else
	{
	    $('.ajax-overlay .progress-bar').css({width: '1%'});
	    $('.ajax-overlay').show({
		complete: function(){
		    $('.ajax-overlay .progress-bar').css({width: '100%'});
		}
	    });

	}

    }
}



// --------------------------------------------------------------------
// paypal api to render button
function initPaypalButton(target, env, keys, transactions, transaction_uid)
{
    if(!$(target).length || !paypal) return;
    
    paypal.Buttons({
	createOrder: function(data, actions) {
	    // Set up the transaction
	    return actions.order.create({
		purchase_units: transactions
	    });
	},
	// Approve
	onApprove: function(data, actions) {
	    var orderId   = data.orderID;
	    var payerId   = data.payerID;
	    
	    return actions.order.capture().then(function(details) {
		// alert('Transaction completed by ' + details.payer.name.given_name);

		var txtResponse   = 'Transaction complétée, en cours de validation.';
		var classResponse = 'success';
		var ofForm        = 'paiement';
		var currentForm   = $('form[data-form=' + ofForm + ']');
		var formCallback  = currentForm.find('.form_callback');
		// show result
		formCallback.removeClass('error success');
		formCallback.html(txtResponse).addClass(classResponse).show();
		$('#paypal-button').hide()
		$('#paypal-button').next('[data-btin]').hide()
		
		// Call the server to save the transaction		
		var success = function (res)
		{	    
		    if(res.response.indexOf('_') > 0)
		    {
			txtResponse   = 'Transaction complétée, en cours de validation. Veuillez patienter...';
			classResponse = 'success';
						
			setTimeout(function(){
			    window.location = 'paiement-' + res.response + '.html';
			}, 500);
		    }
		    else
		    {
			txtResponse   = getCallbackTxt('error');
			classResponse = 'error';
		    }

		    if(txtResponse !== '')
		    {
			// show result
			formCallback.removeClass('error success');
			formCallback.html(txtResponse).addClass(classResponse).show();
		    }
		};

		var data = 'type=paypal.payment&orderId=' + orderId + '&payerId=' + payerId + '&uniqId=' + transaction_uid;
		ajaxPost(data, success);
	    });
	},
	// Payment is canceled
	onCancel: function(data, actions) {
	    /*
	    window.alert('Commande annulée !');
	    console.log(data); // {"orderID": "02V683649A5805805"}
	    console.log(actions); // {}
	    */
	}
    }).render(target);
    
}



/*********************************************************************

objects

*********************************************************************/

// ----- FEelements - is a common object
var FEelements = {

    /**
     *
     * @param elementName string
     * @param search boolean - true for search request
     **/
    displayList : function(elementName, search)
    {
	var data = 'type=' + elementName + '.page&' + $('#' + elementName + '-form').serialize();

	var success = function (res)
	{
	    if(res.response)
	    {
		var content     = '.' + elementName + '-content';
		var elementForm = $('#' + elementName + '-form');
		
		// get container
		var container  = $('[data-db-container="' + elementName + '"]');

		if(container)
		{
		    var dataModule = $('[data-module="' + elementName + '"]');
                    
		    if(dataModule.attr('data-append') && (dataModule.attr('data-append') == 'true') && (parseInt(dataModule.attr('data-page')) > 1))
		    {
			container.find(content).last().after(res.response[1]);                
		    }
		    else
                    {
			container.html(res.response[1]);
                    }    
		    

		    // show last added elements
		    container.find(content).fadeIn(1000);
		    
		    // show message if no element was found
		    if(parseInt(res.response[0]) <= 0)
		    {
			$('[data-dbo="alert"]').addClass('error').show();
		    }
		    else
		    {
			$('[data-dbo="alert"]').removeClass('error').hide();
		    }

		    // reload pagination
		    var dataDbinBack = $('[data-dbin-back="' + elementName + '"]');
		    if(dataModule.attr('data-append') && (dataModule.attr('data-append') == 'true')/* && (parseInt(dataModule.attr('data-page')) !== 1)*/)
		    {
			var dataDbin = $('[data-dbin="' + elementName + '"]');
			dataDbinBack.attr('data-total', res.response[0]);
        		dbin_change_end(dataDbin);
		    }
		    else if(res.response[0] !== parseInt(dataDbinBack.attr('data-total')))
		    {
			dataDbinBack.attr('data-total', res.response[0]).change();
			dbin_change_end(dataDbinBack);
		    }

		    
		}
	    }
	};

	ajaxPost(data, success);

    },


    displaySearch : function(elementName)
    {
	if(!window[ elementName ]) return;

	// reset nav page value
	// $('#' + elementName + '-form #nav_page').val(1);
	
	window[ elementName ].displayList(true);
    },


    initSearch : function(elementName)
    {
	if(!window[ elementName ]) return;

	var data = 'type=' + elementName + '.initsearch&' + $('#' + elementName + '-form').serialize();

	var success = function (res)
	{
	    if(res.response)
	    {
		window.location.href = $('#' + elementName + '-form').attr('action');
	    }
	};

	ajaxPost(data, success);
    },


    /**
     * use pagination
     * call ajax script
     *
     **/
    gotoPage : function(elementName, page)
    {
	if(!window[ elementName ]) return;

	if($('div.pagination-button').length)
	{
	    window[ elementName ].displayList(false);
	}
	else
	{
	    // check the right loader to show
	    var currentPage = parseInt($('#' + elementName + '-form #nav_page').val());
	    page            = parseInt(page);

	    if(page >= currentPage)
	    {
		if($('div.pagination .p_next').length) $('div.pagination .p_next').addClass('loading');
		else if($('div.pagination_multiple .p_next').length) $('div.pagination_multiple .p_next').addClass('loading');
	    }
	    else
	    {
		if($('div.pagination .p_prev').length) $('div.pagination .p_prev').addClass('loading');
		else if($('div.pagination_multiple .p_prev').length) $('div.pagination_multiple .p_prev').addClass('loading');
	    }

	    // update nav page value
	    $('#' + elementName + '-form #nav_page').val(page);

	    window[ elementName ].displayList(true);

	    // get container
	    var container  = $('[data-db-container="' + elementName + '"]');
	    var scroll     = container.offset().top;
	    if($('[data-dbo="categories"]').length)
	    {
		scroll = $('[data-dbo="categories"]').offset().top;
	    }
            var outerHeight = 0;
            if($('#headerDk')) outerHeight = $('#headerDk .container:first-child').outerHeight();
            else if($('#headerMb')) outerHeight = $('#headerMb').outerHeight();
	    $('html, body').animate({
		scrollTop: scroll - outerHeight
	    }, 'slow');
	    
	}
    }




}

// after this line odin modules will be added
//#MOD_CONTACT
if(typeof contact === 'undefined')
{
    var contact = {

        elementName : 'contact',

        send : function(of_Inputs)
        {
            var txtResponse   = '';
            var classResponse = 'success';
            var ofForm        = (of_Inputs.of_form ? of_Inputs.of_form : 'contact');
            var currentForm   = $('form[data-form=' + ofForm + ']');
            var formCallback  = currentForm.find('.form_callback');

            if(of_Inputs.of_email && !checkEmail(of_Inputs.of_email))
            {
		txtResponse   = getCallbackTxt('email');
		classResponse = 'error';
		if(txtResponse != '')
		{
		    // show result
		    formCallback.removeClass('error success');
		    formCallback.html(txtResponse).addClass(classResponse).show();
		}
            }
            else
            {
		of_Inputs         = encodeURIComponent(JSON.stringify(of_Inputs));
		var data          = 'type=' + this.elementName + '.send&of=' + of_Inputs;

		// show loader
		if($('[data-loading]').length) $('[data-loading]').addClass('loading');

		//
		var success = function (res)
		{
		    if(res.response)
		    {
			if(parseInt(res.response) <= 0)
			{
			    classResponse = 'error';
			    txtResponse   = getCallbackTxt('error');
			    if(parseInt(res.response) == -2)
			    {
				txtResponse += getCallbackTxt('nobot');
			    }
			    else if(parseInt(res.response) == -3)
			    {
				txtResponse += getCallbackTxt('required');
			    }
			    else if(parseInt(res.response) == -20)
			    {
				txtResponse += getCallbackTxt('form_rgpd');
			    }
			    else if(parseInt(res.response) == -30)
			    {
				txtResponse += getCallbackTxt('spam_test');
			    }
			}
			else
			{

			    if(ofForm === 'ordonnance')
			    {
				txtResponse = getCallbackTxt('prescription');
			    }
			    else
			    {
				txtResponse = getCallbackTxt('contact');
			    }

			    // set a value to of_validate_input to avoid multiple execution without reloading
			    if(currentForm.find('[name=of_validate_input]').length)
			    {
				currentForm.find('[name=of_validate_input]').val('1');
			    }

			}
		    }

		    if(txtResponse != '')
		    {
			// show result
			formCallback.removeClass('error success');
			formCallback.html(txtResponse).addClass(classResponse).show();
		    }
		};

		ajaxPost(data, success);

            }

        },

	initBooking : function(of_Inputs)
        {
	    var ofForm        = (of_Inputs.of_form ? of_Inputs.of_form : 'reservation');
            var currentForm   = $('form[data-form=' + ofForm + ']');
            var data = 'type=' + this.elementName + '.initbooking&' + currentForm.serialize();

	    var success = function (res)
	    {
		if(res.response)
		{
		    window.location.href = 'contact.html';
		}
	    };

	    ajaxPost(data, success);
        }

    }
}

//#MOD_NEWS
if(typeof news === 'undefined')
{
    var news = {

        elementName : 'news',

        /**
         *
         * @param search boolean - true for search request
         **/
        displayList : function(search)
        {
            FEelements.displayList(this.elementName, search);

        },

        displaySearch : function()
        {
            FEelements.displaySearch(this.elementName);
        },

        /**
         * use pagination
         * call ajax script
         *
         **/
        gotoPage : function(page)
        {
            FEelements.gotoPage(this.elementName, page);
        },

        doLike : function()
        {
            var data = 'type=news.addalike&id=' + $('.news_likes_inner').attr('data-news-id');

            var success = function(res)
            {
                if(res.response)
                {
		    var oldLikes = parseInt($('.news_likes_counter').html());
		    if(oldLikes < parseInt(res.response)) $('.news_likes_inner').attr('data-news-like', '1');
		    else $('.news_likes_inner').attr('data-news-like', '0');
		    $('.news_likes_counter').html(res.response);
		    //
		    news.removePlural();
		};
            }

            ajaxPost(data, success);
        },

        removePlural : function()
        {
            if($('.news_likes_counter').length)
            {
		if(parseInt($('.news_likes_counter').html()) < 2)
                {
		    if($('.news_likes_plural_word')) $('.news_likes_plural_word').hide();
		    if($('.news_likes_plural_verb')) $('.news_likes_plural_verb').hide();
                }
		else
		{
		    if($('.news_likes_plural_word')) $('.news_likes_plural_word').show();
		    if($('.news_likes_plural_verb')) $('.news_likes_plural_verb').show();
		}
            }

        },

        removeFavorite : function ()
        { 
            if(!$('.news_aside_favorites .news').length) 
            {
                if($('.news_aside_favorites')) $('.news_aside_favorites').remove();
            } 
        },

        removeCategories : function ()
        {

            if(!$('.news_aside_categories ul li').length) 
            {
                if($('.news_aside_categories')) $('.news_aside_categories').remove(); 
            }

        }

    }
}

//#MOD_NEWSLETTERS
if(typeof newsletter === 'undefined')
{
    var newsletter = {

        /* do ajax call for subscribing */
        doSubscription : function(of_Inputs)
        {
            var txtResponse   = '';
            var classResponse = 'success';
            var ofForm        = (of_Inputs.of_form ? of_Inputs.of_form : 'newsletter');
            var currentForm   = $('form[data-form=' + ofForm + ']');
            var formCallback  = currentForm.find('.form_callback');

            if(of_Inputs.of_email && !checkEmail(of_Inputs.of_email))
            {
		txtResponse = getCallbackTxt('email');
		if(lang != 'FR') txtResponse = 'Please set a valid e-mail.';

		classResponse = 'error';
		if(txtResponse != '')
		{
		    // show result
		    formCallback.removeClass('error success');
		    formCallback.html(txtResponse).addClass(classResponse).show();
		}
            }
            else
            {
		of_Inputs         = encodeURIComponent(JSON.stringify(of_Inputs));
		var data          = 'type=newsletter.subscribe&of=' + of_Inputs;

		// show loader
		if($('[data-loading]').length) $('[data-loading]').addClass('loading');

		//
		var success = function(res)
		{
		    if(res.response)
		    {
			if(parseInt(res.response) <= 0)
			{
			    classResponse = 'error';
			    txtResponse   = getCallbackTxt('error');
			    if(parseInt(res.response) == -2)
			    {
				txtResponse += getCallbackTxt('nobot');
			    }
			    else if(parseInt(res.response) == -3)
			    {
				txtResponse += getCallbackTxt('required');
			    }
			    else if(parseInt(res.response) == -5)
			    {
				txtResponse += getCallbackTxt('sub_exist');
			    }
			    else if(parseInt(res.response) == -20)
			    {
				txtResponse += getCallbackTxt('form_rgpd');
			    }
			}
			else
			{
			    txtResponse = getCallbackTxt('sub_add');

			    // set a value to of_validate_input to avoid multiple execution without reloading
			    if(currentForm.find('[name=of_validate_input]').length)
			    {
				currentForm.find('[name=of_validate_input]').val('1');
			    }
			}

		    }

		    if(txtResponse != '')
		    {
			// show result
			formCallback.removeClass('error success');
			formCallback.html(txtResponse).addClass(classResponse).show();
		    }
		};

		ajaxPost(data, success);

            }  

            return false;
        },

        /*
          do ajax call for unsubscribing

        */
        doUnsubscribe : function(of_Inputs)
        {
            var txtResponse   = '';
            var classResponse = 'success';
            var ofForm        = (of_Inputs.of_form ? of_Inputs.of_form : 'newsletter');
            var currentForm   = $('form[data-form=' + ofForm + ']');
            var formCallback  = currentForm.find('.form_callback');

            if(of_Inputs.of_email && !checkEmail(of_Inputs.of_email))
            {
		txtResponse = getCallbackTxt('email');
		if(lang != 'FR') txtResponse = 'Please set a valid e-mail.';

		classResponse = 'error';
		if(txtResponse != '')
		{
		    // show result
		    formCallback.removeClass('error success');
		    formCallback.html(txtResponse).addClass(classResponse).show();
		}
            }
            else
            {
		of_Inputs         = encodeURIComponent(JSON.stringify(of_Inputs));
		var data          = 'type=newsletter.unsubscribe&of=' + of_Inputs;

		// show loader
		if($('[data-loading]').length) $('[data-loading]').addClass('loading');

		//
		var success = function(res)
		{
		    if(res.response)
		    {
			if(parseInt(res.response) <= 0)
			{
			    classResponse = 'error';
			    txtResponse   = getCallbackTxt('error');
			    if(parseInt(res.response) == -2)
			    {
				txtResponse += getCallbackTxt('nobot');
			    }
			    else if(parseInt(res.response) == -3)
			    {
				txtResponse += getCallbackTxt('required');
			    }
			    else if(parseInt(res.response) == -20)
			    {
				txtResponse += getCallbackTxt('form_rgpd');
			    }
			}
			else
			{
			    txtResponse = getCallbackTxt('sub_delete');

			    // set a value to of_validate_input to avoid multiple execution without reloading
			    if(currentForm.find('[name=of_validate_input]').length)
			    {
				currentForm.find('[name=of_validate_input]').val('1');
			    }
			}

		    }

		    if(txtResponse != '')
		    {
			// show result
			formCallback.removeClass('error success');
			formCallback.html(txtResponse).addClass(classResponse).show();
		    }
		};

		ajaxPost(data, success);

            }

            return false;
        },

        /*
          do ajax call for subscribing

        */
        prepareSubscription : function()
        {
            if($('#newsemail-2').val() == '') return false;

            var form = $('#newsletterIn').find('#newsletters-form');
            form.find('#newsemail').val($('#newsemail-2').val());

            $('.newsletterIn_toggle').trigger('click');

            form.find('[type=submit]').trigger('click');

            return false;
        }

    }
}

//#MOD_PRESTATIONS
if(typeof prestations === 'undefined')
{
    var prestations = {

        elementName : 'prestations',

        /**
         *
         * @param search boolean - true for search request
         **/
        displayList : function(search)
        {
            FEelements.displayList(this.elementName, search);
        },

        displaySearch : function()
        {
            FEelements.displaySearch(this.elementName);
        },

        /**
         * use pagination
         * call ajax script
         *
         **/
        gotoPage : function(page)
        {
            FEelements.gotoPage(this.elementName, page);
        }

    }
}

//#MOD_PRODUCTS
if(typeof products === 'undefined')
{
    
    var products = {

        elementName : 'products',

        /**
         *
         * @param search boolean - true for search request
         **/
        displayList : function(search)
        {
            FEelements.displayList(this.elementName, search);
        },

        displaySearch : function()
        {
            FEelements.displaySearch(this.elementName);
        },

        /**
         * use pagination
         * call ajax script
         *
         **/
        gotoPage : function(page)
        {
            FEelements.gotoPage(this.elementName, page);
        },

        /**
         * fill element form with values and submit form
         *
         **/
        initSearch : function(of_Inputs)
        {
            var form = '#' + this.elementName + '-form';
            if(!$(form).length)
            {
                $('body').append('<form id="' + this.elementName + '-form" name="' + this.elementName + '-form" method="post" action="pieces_detachees_voitures.html"><input type="hidden" name="module_name" id="module_name" value="' + this.elementName + '"></form>')
            }

            // of_immatriculation: Object { type: "text", value: "interdum", maxlength: "15" }

            if(!$(form).find('input[id=search_title]').length)
            {
                $(form).append('<input type="hidden" name="search_or_title" id="search_or_title" value="">');
                $(form).append('<input type="hidden" name="search_or_text" id="search_or_text" value="">');
            }
            $(form).find('#search_or_title').val('');
            $(form).find('#search_or_text').val('');

            if(of_Inputs['of_immatriculation'] && of_Inputs['of_immatriculation'].value)
            {
                $(form).find('#search_or_title').val('LIKE "%' + of_Inputs['of_immatriculation'].value + '%"');
                $(form).find('#search_or_text').val('LIKE "%' + of_Inputs['of_immatriculation'].value + '%"');

                $(form).submit();
            }
        }

    }
}

//#MOD_USERS
if(typeof users === 'undefined')
{
    var users = {

        elementName : 'users',

        /**
         * download a file
         * 
         **/
        addFile : function(of_Inputs)
        {
            var txtResponse   = '';
            var classResponse = 'success';
            var ofForm        = (of_Inputs.of_form ? of_Inputs.of_form : 'add');
            var currentForm   = $('form[data-form=' + ofForm + ']');
            var formCallback  = currentForm.find('.form_callback');

            of_Inputs         = encodeURIComponent(JSON.stringify(of_Inputs));
            var data          = 'type=' + this.elementName + '.addfile&of=' + of_Inputs;

            // show loader
            if($('[data-loading]').length) $('[data-loading]').addClass('loading');

            //
            var success = function (res)
            {
		if(res.response)
		{
		    if(parseInt(res.response) <= 0)
		    {
			classResponse = 'error';
			txtResponse   = getCallbackTxt('error');
			if(parseInt(res.response) == -2)
			{
			    txtResponse += getCallbackTxt('nobot');
			}
			else if(parseInt(res.response) == -3)
			{
			    txtResponse += getCallbackTxt('required');
			}
		    }
		    else
		    {
			txtResponse = getCallbackTxt('file_dld');

			// set a value to of_validate_input to avoid multiple execution without reloading
			if(currentForm.find('[name=of_validate_input]').length)
			{
			    currentForm.find('[name=of_validate_input]').val('1');
			}

			// reload list of files
			setTimeout(function(){
			    location.reload();
			}, 1000);

		    }
		}

		if(txtResponse != '')
		{
		    // show result
		    formCallback.removeClass('error success');
		    formCallback.html(txtResponse).addClass(classResponse).show();
		}
            };

            ajaxPost(data, success);

        },

        /**
         * add a message
         * 
         **/
        addMessage : function(of_Inputs)
        {
            var txtResponse   = '';
            var classResponse = 'success';
            var ofForm        = (of_Inputs.of_form ? of_Inputs.of_form : 'messagerie');
            var currentForm   = $('form[data-form=' + ofForm + ']');
            var formCallback  = currentForm.find('.form_callback');

            of_Inputs         = encodeURIComponent(JSON.stringify(of_Inputs));
            var data          = 'type=' + this.elementName + '.addmessage&of=' + of_Inputs;

            // show loader
            if($('[data-loading]').length) $('[data-loading]').addClass('loading');

            //
            var success = function (res)
            {
		if(res.response)
		{
		    if(parseInt(res.response) > 0)
		    {
			// set a value to of_validate_input to avoid multiple execution without reloading
			if(currentForm.find('[name=of_validate_input]').length)
			{
			    currentForm.find('[name=of_validate_input]').val('1');
			}

			// add the message to list
			var msgContainerTmpl = $('div.messages').find('div.message_hidden').last();
			var msgContainer     = msgContainerTmpl.clone();
			msgContainer.removeClass('message_hidden').addClass('sent');
			msgContainer.find('div').html(nl2br($('[name=of_message]').val(), false));
			var date = new Date();
			date = date.toLocaleDateString('fr-FR') + ', ' + date.getHours() + ':' + date.getMinutes() + ':' + date.getSeconds();
			msgContainer.attr('title', 'Message envoyé le ' + date);
			$('div.messages').append(msgContainer);
			// scroll to last message added
			$('div.messages').scrollTop(1E10);
			// and reset input
			$('[name=of_message]').val('');
		    }
		}

		if(txtResponse != '')
		{
		    // show result
		    formCallback.removeClass('error success');
		    formCallback.html(txtResponse).addClass(classResponse).show();
		}
            };

            ajaxPost(data, success);

        },

        /**
         * create user
         * 
         **/
        create : function(of_Inputs)
        {
            var txtResponse   = '';
            var classResponse = 'success';
            var ofForm        = (of_Inputs.of_form ? of_Inputs.of_form : 'creation-particulier');
            var currentForm   = $('form[data-form=' + ofForm + ']');
            var formCallback  = currentForm.find('.form_callback');

            of_Inputs         = encodeURIComponent(JSON.stringify(of_Inputs));
            var data          = 'type=' + this.elementName + '.create&of=' + of_Inputs;

            // show loader
            if($('[data-loading]').length) $('[data-loading]').addClass('loading');

            //
            var success = function (res)
            {
		if(res.response)
		{
		    if(parseInt(res.response) <= 0)
		    {
			classResponse = 'error';
			txtResponse   = getCallbackTxt('error');
			if(parseInt(res.response) == -2)
			{
			    txtResponse += getCallbackTxt('nobot');
			}
			else if(parseInt(res.response) == -3)
			{
			    txtResponse += getCallbackTxt('required');
			}
			else if(parseInt(res.response) == -6)
			{
			    txtResponse += getCallbackTxt('sub_pwd_confirm_error');
			}
		    }
		    else
		    {
			txtResponse = getCallbackTxt('sub_add');

			// set a value to of_validate_input to avoid multiple execution without reloading
			if(currentForm.find('[name=of_validate_input]').length)
			{
			    currentForm.find('[name=of_validate_input]').val('1');
			}

			// reload page
			setTimeout(function(){
			    if(checkBookingCookies())
			    {
				window.location = 'reservation.html';
			    }
			    else
			    {
				location.reload();
			    }
			}, 1000);

		    }
		}

		if(txtResponse != '')
		{
		    // show result
		    formCallback.removeClass('error success');
		    formCallback.html(txtResponse).addClass(classResponse).show();
		}
            };

            ajaxPost(data, success);

        },

        /**
         * log user
         * reload location if login is successful
         **/
        doLogin : function(of_Inputs)
        {
            var txtResponse   = '';
            var classResponse = 'success';
            var ofForm        = (of_Inputs.of_form ? of_Inputs.of_form : 'login');
            var currentForm   = $('form[data-form=' + ofForm + ']');
            var formCallback  = currentForm.find('.form_callback');

            of_Inputs         = encodeURIComponent(JSON.stringify(of_Inputs));
            var data          = 'type=' + this.elementName + '.dologin&of=' + of_Inputs;

            // show loader
            if($('[data-loading]').length) $('[data-loading]').addClass('loading');

            //
            var success = function (res)
            {
		if(res.response)
		{
		    if(parseInt(res.response) <= 0)
		    {
			classResponse = 'error';
			txtResponse   = getCallbackTxt('error');
			if(parseInt(res.response) == -2)
			{
			    txtResponse += getCallbackTxt('nobot');
			}
			else if(parseInt(res.response) == -3)
			{
			    txtResponse += getCallbackTxt('required');
			}
			else if(parseInt(res.response) == -7)
			{
			    txtResponse += getCallbackTxt('no_account');
			}
			else if(parseInt(res.response) == -8)
			{
			    txtResponse += getCallbackTxt('wrong_pwd');
			}
		    }
		    else
		    {
			txtResponse = getCallbackTxt('connection');

			// set a value to of_validate_input to avoid multiple execution without reloading
			if(currentForm.find('[name=of_validate_input]').length)
			{
			    currentForm.find('[name=of_validate_input]').val('1');
			}

			// reload page
			setTimeout(function(){
			    if(checkBookingCookies())
			    {
				window.location = 'reservation.html';
			    }
			    else location.reload();
			}, 300);

		    }
		}

		if(txtResponse != '')
		{
		    // show result
		    formCallback.removeClass('error success');
		    formCallback.html(txtResponse).addClass(classResponse).show();
		}
            };

            ajaxPost(data, success);

        },

        /**
         * log user
         * reload location if login is successful
         **/
        doLogout : function()
        {
            var data          = 'type=' + this.elementName + '.dologout';

            // show loader
            if($('[data-loading]').length) $('[data-loading]').addClass('loading');

            //
            var success = function (res)
            {
		if(res.response)
		{
		    // reload page
		    setTimeout(function(){
			location.reload();
		    }, 300);
		}
            };

            ajaxPost(data, success);

        },

        /**
         * retrieve password for user
         *
         **/
        retrievePwd : function(of_Inputs)
        {
            var txtResponse   = '';
            var classResponse = 'success';
            var ofForm        = (of_Inputs.of_form ? of_Inputs.of_form : 'recuperation-1');
            var currentForm   = $('form[data-form=' + ofForm + ']');
            var formCallback  = currentForm.find('.form_callback');

            of_Inputs         = encodeURIComponent(JSON.stringify(of_Inputs));
            var data          = 'type=' + this.elementName + '.retrievepwd&of=' + of_Inputs;

            // show loader
            if($('[data-loading]').length) $('[data-loading]').addClass('loading');

            //
            var success = function (res)
            {
		if(res.response)
		{
		    if(parseInt(res.response) <= 0)
		    {
			classResponse = 'error';
			txtResponse   = getCallbackTxt('error');
			if(parseInt(res.response) == -2)
			{
			    txtResponse += getCallbackTxt('nobot');
			}
			else if(parseInt(res.response) == -3)
			{
			    txtResponse += getCallbackTxt('required');
			}
		    }
		    else
		    {
			txtResponse = getCallbackTxt('user_pwd_change_request');

			// set a value to of_validate_input to avoid multiple execution without reloading
			if(currentForm.find('[name=of_validate_input]').length)
			{
			    currentForm.find('[name=of_validate_input]').val('1');
			}
		    }
		}

		if(txtResponse != '')
		{
		    // show result
		    formCallback.removeClass('error success');
		    formCallback.html(txtResponse).addClass(classResponse).show();
		}
            };

            ajaxPost(data, success);

        },

        /**
         * reset password for user
         *
         **/
        reinitPwd : function(of_Inputs)
        {
            var txtResponse   = '';
            var classResponse = 'success';
            var ofForm        = (of_Inputs.of_form ? of_Inputs.of_form : 'recuperation-2');
            var currentForm   = $('form[data-form=' + ofForm + ']');
            var formCallback  = currentForm.find('.form_callback');

            of_Inputs         = encodeURIComponent(JSON.stringify(of_Inputs));
            var data          = 'type=' + this.elementName + '.reinitpwd&of=' + of_Inputs;

            // show loader
            if($('[data-loading]').length) $('[data-loading]').addClass('loading');

            //
            var success = function (res)
            {
		if(res.response)
		{
		    if(parseInt(res.response) <= 0)
		    {
			classResponse = 'error';
			txtResponse   = getCallbackTxt('error');
			if(parseInt(res.response) == -2)
			{
			    txtResponse += getCallbackTxt('nobot');
			}
			else if(parseInt(res.response) == -3)
			{
			    txtResponse += getCallbackTxt('required');
			}
		    }
		    else
		    {
			txtResponse = getCallbackTxt('user_pwd_update');

			// set a value to of_validate_input to avoid multiple execution without reloading
			if(currentForm.find('[name=of_validate_input]').length)
			{
			    currentForm.find('[name=of_validate_input]').val('1');
			}

			// reload page
			setTimeout(function(){
			    window.location = 'recuperation-ok.html';
			}, 1000);
		    }
		}

		if(txtResponse != '')
		{
		    // show result
		    formCallback.removeClass('error success');
		    formCallback.html(txtResponse).addClass(classResponse).show();
		}

            };

            ajaxPost(data, success);

        },

        /**
         * update user datas
         * 
         **/
        update : function(of_Inputs)
        {
            var txtResponse   = '';
            var classResponse = 'success';
            var ofForm        = (of_Inputs.of_form ? of_Inputs.of_form : 'modifications-1');
            var currentForm   = $('form[data-form=' + ofForm + ']');
            var formCallback  = currentForm.find('.form_callback');

            of_Inputs         = encodeURIComponent(JSON.stringify(of_Inputs));
            var data          = 'type=' + this.elementName + '.update&of=' + of_Inputs;

            // show loader
            if($('[data-loading]').length) $('[data-loading]').addClass('loading');

            //
            var success = function (res)
            {
		if(res.response)
		{
		    if(parseInt(res.response) <= 0)
		    {
			classResponse = 'error';
			txtResponse   = getCallbackTxt('error');
			if(parseInt(res.response) == -2)
			{
			    txtResponse += getCallbackTxt('nobot');
			}
			else if(parseInt(res.response) == -3)
			{
			    txtResponse += getCallbackTxt('required');
			}
			else if(parseInt(res.response) == -8)
			{
			    txtResponse += getCallbackTxt('wrong_pwd');
			}
		    }
		    else
		    {
			txtResponse = getCallbackTxt('user_update');

			// set a value to of_validate_input to avoid multiple execution without reloading
			if(currentForm.find('[name=of_validate_input]').length)
			{
			    currentForm.find('[name=of_validate_input]').val('1');
			}
		    }
		}

		if(txtResponse != '')
		{
		    // show result
		    formCallback.removeClass('error success');
		    formCallback.html(txtResponse).addClass(classResponse).show();
		}
            };

            ajaxPost(data, success);

        }    

    }
    
}

//#MODULES_SCRIPTS

