/**
 * jquery.hoverdir.js v1.1.2
 * http://www.codrops.com
 *
 * Licensed under the MIT license.
 * http://www.opensource.org/licenses/mit-license.php
 *
 * Copyright 2012, Codrops
 * http://www.codrops.com
 */
!function(t){"use strict";"function"==typeof define&&define.amd?define(["jquery"],t):"undefined"!=typeof exports?module.exports=t(require("jquery")):t(jQuery)}(function(o){"use strict";function r(t,e){this.$el=o(t),
// set options
this.options=o.extend(!0,{},this.defaults,e),
// initialize visibility to false for show and hide method
this.isVisible=!1,
// get the hover for this element
this.$hoverElem=this.$el.find(this.options.hoverElem),
// transition properties
this.transitionProp="all "+this.options.speed+"ms "+this.options.easing,
// support for CSS transitions
this.support=this._supportsTransitions(),
// load the events
this._loadEvents()}r.prototype={defaults:{speed:300,easing:"ease",hoverDelay:0,inverse:!1,hoverElem:"div"},constructor:r,
/**
         * Detect if CSS transitions are supported
         *
         * @return {Boolean}
         */
_supportsTransitions:function(){if("undefined"!=typeof Modernizr)return Modernizr.csstransitions;var t,e=(document.body||document.documentElement).style,i="transition";if("string"==typeof e[i])return!0;
// Tests for vendor specific prop
var s=["Moz","webkit","Webkit","Khtml","O","ms"];i=i.charAt(0).toUpperCase()+i.substr(1);for(var o=0;o<s.length;o++)if("string"==typeof e[s[o]+i])return!0;return!1},
/**
         * Bind the events to the element
         */
_loadEvents:function(){this.$el.on("mouseenter.hoverdir mouseleave.hoverdir",o.proxy(function(t){this.direction=this._getDir({x:t.pageX,y:t.pageY}),"mouseenter"===t.type?this._showHover():this._hideHover()},this))},
/**
         * Show the hover of the element
         */
_showHover:function(){var t=this._getStyle(this.direction);this.support&&this.$hoverElem.css("transition",""),this.$hoverElem.hide().css(t.from),clearTimeout(this.tmhover),this.tmhover=setTimeout(o.proxy(function(){this.$hoverElem.show(0,o.proxy(function(){this.support&&this.$hoverElem.css("transition",this.transitionProp),this._applyAnimation(t.to)},this))},this),this.options.hoverDelay),this.isVisible=!0},
/**
         * Hide the hover to the element
         */
_hideHover:function(){var t=this._getStyle(this.direction);this.support&&this.$hoverElem.css("transition",this.transitionProp),clearTimeout(this.tmhover),this._applyAnimation(t.from),this.isVisible=!1},
/**
         * get the direction when the event is triggered
         * credits : http://stackoverflow.com/a/3647634
         *
         * @param {Object} coordinates
         * @returns {Interger}
         */
_getDir:function(t){
// the width and height of the current div
var e=this.$el.width(),i=this.$el.height(),
// calculate the x and y to get an angle to the center of the div from that x and y.
// gets the x value relative to the center of the DIV and "normalize" it
s=(t.x-this.$el.offset().left-e/2)*(i<e?i/e:1),o=(t.y-this.$el.offset().top-i/2)*(e<i?e/i:1),
// the angle and the direction from where the mouse came in/went out clockwise (TRBL=0123);
// first calculate the angle of the point,
// add 180 deg to get rid of the negative values
// divide by 90 to get the quadrant
// add 3 and do a modulo by 4 to shift the quadrants to a proper clockwise TRBL (top/right/bottom/left) **/
r;return Math.round((Math.atan2(o,s)*(180/Math.PI)+180)/90+3)%4},
/**
         * get the style when the event is triggered
         *
         * @param {(Interger|String)} direction
         * @returns {Object}
         */
_getStyle:function(t){var e,i,s={left:"0",top:"-100%"},o={left:"0",top:"100%"},r={left:"-100%",top:"0"},n={left:"100%",top:"0"},h={top:"0"},a={left:"0"};switch(t){case 0:case"top":
// from top
e=this.options.inverse?o:s,i=h;break;case 1:case"right":
// from right
e=this.options.inverse?r:n,i=a;break;case 2:case"bottom":
// from bottom
e=this.options.inverse?s:o,i=h;break;case 3:case"left":
// from left
e=this.options.inverse?n:r,i=a;break}return{from:e,to:i}},
/**
         * Apply a transition or fallback to jquery animate based on Modernizr.csstransitions support
         *
         * @param {Object} styleCSS
         */
_applyAnimation:function(t){o.fn.applyStyle=this.support?o.fn.css:o.fn.animate,this.$hoverElem.stop().applyStyle(t,o.extend(!0,[],{duration:this.options.speed}))},
/**
         * Show $hoverElem from the direction in argument
         *
         * @param {String} [direction=top] direction
         */
show:function(t){this.$el.off("mouseenter.hoverdir mouseleave.hoverdir"),this.isVisible||(this.direction=t||"top",this._showHover())},
/**
         * Hide $hoverElem from the direction in argument
         *
         * @param {String} [direction=bottom] direction
         */
hide:function(t){this.rebuild(),this.isVisible&&(this.direction=t||"bottom",this._hideHover())},setOptions:function(t){this.options=o.extend(!0,{},this.defaults,this.options,t)},
/**
         * Unbinds the plugin.
         */
destroy:function(){this.$el.off("mouseenter.hoverdir mouseleave.hoverdir"),this.$el.data("hoverdir",null)},
/**
         * Bind the plugin.
         */
rebuild:function(t){"object"==typeof t&&this.setOptions(t),this._loadEvents()}},o.fn.hoverdir=function(i,s){return this.each(function(){var t=o(this).data("hoverdir"),e;
// Initialize hoverdir.
t||(t=new r(this,"object"==typeof i&&i),o(this).data("hoverdir",t)),
// Call hoverdir method.
"string"==typeof i&&(t[i](s),"destroy"===i&&o(this).data("hoverdir",!1))})},o.fn.hoverdir.Constructor=r});